chiark / gitweb /
Get rid of backticks in test-lib.sh
[stgit] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 # Copyright (c) 2006 Yann Dirson - tuning for stgit
5 #
6
7 # Keep the original TERM for say_color
8 ORIGINAL_TERM=$TERM
9
10 # For repeatability, reset the environment to known value.
11 LANG=C
12 LC_ALL=C
13 PAGER=cat
14 TZ=UTC
15 TERM=dumb
16 export LANG LC_ALL PAGER TERM TZ
17 EDITOR=:
18 VISUAL=:
19 unset GIT_EDITOR
20 unset AUTHOR_DATE
21 unset AUTHOR_EMAIL
22 unset AUTHOR_NAME
23 unset COMMIT_AUTHOR_EMAIL
24 unset COMMIT_AUTHOR_NAME
25 unset EMAIL
26 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
27 unset GIT_AUTHOR_DATE
28 GIT_AUTHOR_EMAIL=author@example.com
29 GIT_AUTHOR_NAME='A U Thor'
30 unset GIT_COMMITTER_DATE
31 GIT_COMMITTER_EMAIL=committer@example.com
32 GIT_COMMITTER_NAME='C O Mitter'
33 unset GIT_DIFF_OPTS
34 unset GIT_DIR
35 unset GIT_WORK_TREE
36 unset GIT_EXTERNAL_DIFF
37 unset GIT_INDEX_FILE
38 unset GIT_OBJECT_DIRECTORY
39 unset SHA1_FILE_DIRECTORIES
40 unset SHA1_FILE_DIRECTORY
41 GIT_MERGE_VERBOSITY=5
42 export GIT_MERGE_VERBOSITY
43 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
44 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
45 export EDITOR VISUAL
46 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
47
48 # Protect ourselves from common misconfiguration to export
49 # CDPATH into the environment
50 unset CDPATH
51
52 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
53         1|2|true)
54                 echo "* warning: Some tests will not work if GIT_TRACE" \
55                         "is set as to trace on STDERR ! *"
56                 echo "* warning: Please set GIT_TRACE to something" \
57                         "other than 1, 2 or true ! *"
58                 ;;
59 esac
60
61 # Each test should start with something like this, after copyright notices:
62 #
63 # test_description='Description of this test...
64 # This test checks if command xyzzy does the right thing...
65 # '
66 # . ./test-lib.sh
67 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
68                 TERM=$ORIGINAL_TERM &&
69                 export TERM &&
70                 [ -t 1 ] &&
71                 tput bold >/dev/null 2>&1 &&
72                 tput setaf 1 >/dev/null 2>&1 &&
73                 tput sgr0 >/dev/null 2>&1
74         ) &&
75         color=t
76
77 while test "$#" -ne 0
78 do
79         case "$1" in
80         -d|--d|--de|--deb|--debu|--debug)
81                 debug=t; shift ;;
82         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
83                 immediate=t; shift ;;
84         -h|--h|--he|--hel|--help)
85                 help=t; shift ;;
86         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
87                 export STGIT_DEBUG_LEVEL="-1"
88                 verbose=t; shift ;;
89         -q|--q|--qu|--qui|--quie|--quiet)
90                 quiet=t; shift ;;
91         --no-color)
92                 color=; shift ;;
93         *)
94                 break ;;
95         esac
96 done
97
98 if test -n "$color"; then
99         say_color () {
100                 (
101                 TERM=$ORIGINAL_TERM
102                 export TERM
103                 case "$1" in
104                         error) tput bold; tput setaf 1;; # bold red
105                         skip)  tput bold; tput setaf 2;; # bold green
106                         pass)  tput setaf 2;;            # green
107                         info)  tput setaf 3;;            # brown
108                         *) test -n "$quiet" && return;;
109                 esac
110                 shift
111                 echo "* $*"
112                 tput sgr0
113                 )
114         }
115 else
116         say_color() {
117                 test -z "$1" && test -n "$quiet" && return
118                 shift
119                 echo "* $*"
120         }
121 fi
122
123 error () {
124         say_color error "error: $*"
125         trap - exit
126         exit 1
127 }
128
129 say () {
130         say_color info "$*"
131 }
132
133 test "${test_description}" != "" ||
134 error "Test script did not set test_description."
135
136 if test "$help" = "t"
137 then
138         echo "$test_description"
139         exit 0
140 fi
141
142 exec 5>&1
143 if test "$verbose" = "t"
144 then
145         exec 4>&2 3>&1
146 else
147         exec 4>/dev/null 3>/dev/null
148 fi
149
150 test_failure=0
151 test_count=0
152 test_fixed=0
153 test_broken=0
154
155 die () {
156         echo >&5 "FATAL: Unexpected exit with code $?"
157         exit 1
158 }
159
160 trap 'die' exit
161
162 test_tick () {
163         if test -z "${test_tick+set}"
164         then
165                 test_tick=1112911993
166         else
167                 test_tick=$(($test_tick + 60))
168         fi
169         GIT_COMMITTER_DATE="$test_tick -0700"
170         GIT_AUTHOR_DATE="$test_tick -0700"
171         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
172 }
173
174 # You are not expected to call test_ok_ and test_failure_ directly, use
175 # the text_expect_* functions instead.
176
177 test_ok_ () {
178         test_count=$(expr "$test_count" + 1)
179         say_color "" "  ok $test_count: $@"
180 }
181
182 test_failure_ () {
183         test_count=$(expr "$test_count" + 1)
184         test_failure=$(expr "$test_failure" + 1);
185         say_color error "FAIL $test_count: $1"
186         shift
187         echo "$@" | sed -e 's/^/        /'
188         test "$immediate" = "" || { trap - exit; exit 1; }
189 }
190
191 test_known_broken_ok_ () {
192         test_count=$(expr "$test_count" + 1)
193         test_fixed=$(($test_fixed+1))
194         say_color "" "  FIXED $test_count: $@"
195 }
196
197 test_known_broken_failure_ () {
198         test_count=$(expr "$test_count" + 1)
199         test_broken=$(($test_broken+1))
200         say_color skip "  still broken $test_count: $@"
201 }
202
203 test_debug () {
204         test "$debug" = "" || eval "$1"
205 }
206
207 test_run_ () {
208         eval >&3 2>&4 "$1"
209         eval_ret="$?"
210         return 0
211 }
212
213 test_skip () {
214         this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
215         this_test="$this_test.$(expr "$test_count" + 1)"
216         to_skip=
217         for skp in $GIT_SKIP_TESTS
218         do
219                 case "$this_test" in
220                 $skp)
221                         to_skip=t
222                 esac
223         done
224         case "$to_skip" in
225         t)
226                 say_color skip >&3 "skipping test: $@"
227                 test_count=$(expr "$test_count" + 1)
228                 say_color skip "skip $test_count: $1"
229                 : true
230                 ;;
231         *)
232                 false
233                 ;;
234         esac
235 }
236
237 test_expect_failure () {
238         test "$#" = 2 ||
239         error "bug in the test script: not 2 parameters to test-expect-failure"
240         if ! test_skip "$@"
241         then
242                 say >&3 "checking known breakage: $2"
243                 test_run_ "$2"
244                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
245                 then
246                         test_known_broken_ok_ "$1"
247                 else
248                     test_known_broken_failure_ "$1"
249                 fi
250         fi
251         echo >&3 ""
252 }
253
254 test_expect_success () {
255         test "$#" = 2 ||
256         error "bug in the test script: not 2 parameters to test-expect-success"
257         if ! test_skip "$@"
258         then
259                 say >&3 "expecting success: $2"
260                 test_run_ "$2"
261                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
262                 then
263                         test_ok_ "$1"
264                 else
265                         test_failure_ "$@"
266                 fi
267         fi
268         echo >&3 ""
269 }
270
271 test_expect_code () {
272         test "$#" = 3 ||
273         error "bug in the test script: not 3 parameters to test-expect-code"
274         if ! test_skip "$@"
275         then
276                 say >&3 "expecting exit code $1: $3"
277                 test_run_ "$3"
278                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
279                 then
280                         test_ok_ "$2"
281                 else
282                         test_failure_ "$@"
283                 fi
284         fi
285         echo >&3 ""
286 }
287
288 # test_cmp is a helper function to compare actual and expected output.
289 # You can use it like:
290 #
291 #       test_expect_success 'foo works' '
292 #               echo expected >expected &&
293 #               foo >actual &&
294 #               test_cmp expected actual
295 #       '
296 #
297 # This could be written as either "cmp" or "diff -u", but:
298 # - cmp's output is not nearly as easy to read as diff -u
299 # - not all diff versions understand "-u"
300
301 test_cmp() {
302         $GIT_TEST_CMP "$@"
303 }
304
305 # Most tests can use the created repository, but some may need to create more.
306 # Usage: test_create_repo <directory>
307 test_create_repo () {
308         test "$#" = 1 ||
309         error "bug in the test script: not 1 parameter to test-create-repo"
310         owd=$(pwd)
311         repo="$1"
312         mkdir "$repo"
313         cd "$repo" || error "Cannot setup test environment"
314         git init >/dev/null 2>&1 || error "cannot run git init"
315         echo "empty start" | \
316             git commit-tree $(git write-tree) >.git/refs/heads/master 2>&4 || \
317             error "cannot run git commit"
318         mv .git/hooks .git/hooks-disabled
319         cd "$owd"
320 }
321
322 test_done () {
323         trap - exit
324
325         if test "$test_fixed" != 0
326         then
327                 say_color pass "fixed $test_fixed known breakage(s)"
328         fi
329         if test "$test_broken" != 0
330         then
331                 say_color error "still have $test_broken known breakage(s)"
332                 msg="remaining $(($test_count-$test_broken)) test(s)"
333         else
334                 msg="$test_count test(s)"
335         fi
336         case "$test_failure" in
337         0)
338                 # We could:
339                 # cd .. && rm -fr trash
340                 # but that means we forbid any tests that use their own
341                 # subdirectory from calling test_done without coming back
342                 # to where they started from.
343                 # The Makefile provided will clean this test area so
344                 # we will leave things as they are.
345
346                 say_color pass "passed all $msg"
347                 exit 0 ;;
348
349         *)
350                 say_color error "failed $test_failure among $msg"
351                 exit 1 ;;
352
353         esac
354 }
355
356 # Test the binaries we have just built.  The tests are kept in
357 # t/ subdirectory and are run in trash subdirectory.
358 PATH=$(pwd)/..:$PATH
359 HOME=$(pwd)/trash
360 GIT_CONFIG=.git/config
361 export PATH HOME GIT_CONFIG
362
363 # Test repository
364 test=trash
365 rm -fr "$test" || {
366         trap - exit
367         echo >&5 "FATAL: Cannot prepare test area"
368         exit 1
369 }
370
371 test_create_repo $test
372 cd "$test"
373
374 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
375 for skp in $GIT_SKIP_TESTS
376 do
377         to_skip=
378         for skp in $GIT_SKIP_TESTS
379         do
380                 case "$this_test" in
381                 $skp)
382                         to_skip=t
383                 esac
384         done
385         case "$to_skip" in
386         t)
387                 say_color skip >&3 "skipping test $this_test altogether"
388                 say_color skip "skip all tests in $this_test"
389                 test_done
390         esac
391 done